<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<form [formGroup]="form" novalidate autocomplete="off">
  <mat-card id="testingCardsLotEdit" [class.read-only]="readOnly">
    <mat-card-header>
      <mat-card-title>{{ "testing-cards-lot.title" | translate }}</mat-card-title>
      <mat-card-subtitle fxLayout fxLayoutAlign="space-between">
        <span>{{ "testing-cards-lot.subtitle." + mode | translate }}</span>
        <span *ngIf="!readOnly">{{'global.forms.fields.required' | translate}}</span>
      </mat-card-subtitle>
    </mat-card-header>

    <mat-card-content class="no-padding">

      <div class="input-row" fxLayout="row wrap"  fxLayoutGap="2.5rem">
        <mat-form-field fxFlex="1 0 20rem">
          <input matInput
                 name="lotName"
                 formControlName="lotName"
                 required
                 maxlength="20"
                 placeholder="{{'testing-cards-lot.form.placeholder.lot-name' | translate  }}">
          <mat-error>
            <default-errors [fieldName]="'lotName'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>

        <div fxFlex="1 0 20rem"></div>
        <div fxFlex="1 0 20rem"></div>
        <div fxFlex="1 0 20rem"></div>
      </div>

      <div class="input-row" fxLayout="row wrap" fxLayoutGap="2.5rem">

        <mat-form-field fxFlex="1 0 20rem">
          <mat-select name="cardType" formControlName="cardType" (selectionChange)="updateShouldPrint(true)"
                      placeholder="{{'testing-cards-lot.form.placeholder.' + (forConfiguration?'card-type-fixed':'card-type')  | translate  }}">
            <mat-option *ngFor="let possibleValue of cardTypePossibleValues" [value]="possibleValue">
              {{"dictionary.card-type." + possibleValue | translate}}
            </mat-option>
          </mat-select>
          <mat-error>
            <default-errors [fieldName]="'cardType'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>

        <div fxFlex="1 0 20rem">
          <div class="as-fixed-placeholder">
            {{'testing-cards-lot.form.placeholder.should-print' | translate }}
          </div>

          <mat-slide-toggle #shouldPrint name="shouldPrint" color="primary" formControlName="shouldPrint">
            <span [class.disabled]="shouldPrint.disabled">{{'testing-cards-lot.form.values.should-print.' + shouldPrint.checked | translate }}</span>
          </mat-slide-toggle>
        </div>

        <mat-form-field fxFlex="1 0 20rem">
          <input maxlength="6"
                 matInput
                 name="count"
                 type="number"
                 formControlName="count"
                 min="1"
                 max="1000"
                 required
                 placeholder="{{'testing-cards-lot.form.placeholder.count' | translate  }}">
          <mat-error>
            <default-errors [fieldName]="'count'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>

        <div fxFlex="1 0 20rem">
          <div class="as-fixed-placeholder">
            <span class="readonly-label">
              {{'testing-cards-lot.form.placeholder.printer' | translate }}
            </span>
          </div>
          <span class="readonly-value" id="printer" [class.disabled]="true">
            {{ printerName }}
          </span>
        </div>
      </div>

      <mat-divider></mat-divider>

      <div class="input-row">
        <h2>
          {{'testing-cards-lot.form.voter-sub-section-title' | translate }}
        </h2>
      </div>

      <div class="input-row" fxLayout="row wrap" fxLayoutGap="2.5rem">

        <mat-form-field fxFlex="50 0 20rem">
          <mat-select required name="signature" formControlName="signature"
                      placeholder="{{'testing-cards-lot.form.placeholder.signature' | translate  }}">
            <mat-option *ngFor="let possibleValue of signaturePossibleValues" [value]="possibleValue">
              {{"dictionary.signature." + possibleValue | translate}}
            </mat-option>
          </mat-select>
          <mat-error>
            <default-errors [fieldName]="'signature'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>

        <mat-form-field fxFlex="50 0 20rem">

          <input matInput
                 required
                 maxlength="30"
                 name="firstName"
                 formControlName="firstName"
                 placeholder="{{'testing-cards-lot.form.placeholder.first-name' | translate  }}">
          <mat-error>
            <default-errors [fieldName]="'firstName'" [form]="form"></default-errors>
          </mat-error>

        </mat-form-field>

        <mat-form-field fxFlex="50 0 20rem">
          <input matInput
                 required
                 maxlength="30"
                 name="lastName"
                 formControlName="lastName"
                 placeholder="{{'testing-cards-lot.form.placeholder.last-name' | translate  }}">
          <mat-error>
            <default-errors [fieldName]="'lastName'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>

        <mat-form-field fxFlex="50 0 20rem">
          <mat-placeholder>{{'testing-cards-lot.form.placeholder.birthday' | translate }}</mat-placeholder>
          <mat-datetimepicker-toggle [for]="birthDatepicker" matSuffix></mat-datetimepicker-toggle>
          <mat-datetimepicker #birthDatepicker type="date" timeInterval="5"></mat-datetimepicker>
          <input matInput
                 required
                 name="birthday"
                 formControlName="birthday"
                 [matDatetimepicker]="birthDatepicker"
                 autocomplete="false">
          <mat-error>
            <default-errors [fieldName]="'birthday'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>

      </div>

      <div class="input-row" fxLayout="row wrap" fxLayoutGap="2.5rem">
        <mat-form-field fxFlex="50 0 20rem">
          <input matInput
                 required
                 name="street"
                 maxlength="100"
                 formControlName="street"
                 placeholder="{{'testing-cards-lot.form.placeholder.street' | translate  }}">
          <mat-error>
            <default-errors [fieldName]="'street'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>
      </div>

      <div class="input-row address1" fxLayout="row wrap" fxLayoutGap="2.5rem">

        <mat-form-field fxFlex="50 0 20rem">
          <input matInput
                 name="address1"
                 formControlName="address1"
                 maxlength="200"
                 placeholder="{{'testing-cards-lot.form.placeholder.address1' | translate  }}">
          <mat-error>
            <default-errors [fieldName]="'address1'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>
      </div>

      <div class="input-row" fxLayout="row wrap" fxLayoutGap="2.5rem">
        <mat-form-field fxFlex="50 0 20rem">
          <input matInput
                 name="address2"
                 maxlength="200"
                 formControlName="address2">

          <mat-error>
            <default-errors [fieldName]="'address2'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>
      </div>


      <div class="input-row" fxLayout="row wrap" fxLayoutGap="2.5rem">
        <mat-form-field fxFlex="50 0 20rem">
          <input matInput
                 required
                 name="postalCode"
                 maxlength="6"
                 formControlName="postalCode"
                 placeholder="{{'testing-cards-lot.form.placeholder.postal-code' | translate  }}">
          <mat-error>
            <default-errors [fieldName]="'postalCode'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>

        <mat-form-field fxFlex="50 0 20rem">
          <input matInput
                 required
                 name="city"
                 formControlName="city"
                 maxlength="50"
                 placeholder="{{'testing-cards-lot.form.placeholder.city' | translate  }}">
          <mat-error>
            <default-errors [fieldName]="'city'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>
      </div>

      <div class="input-row" fxLayout="row wrap" fxLayoutGap="2.5rem">
        <mat-form-field fxFlex="50 0 20rem">
          <input matInput
                 required
                 name="country"
                 formControlName="country"
                 maxlength="50"
                 placeholder="{{'testing-cards-lot.form.placeholder.country' | translate  }}">
          <mat-error>
            <default-errors [fieldName]="'country'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>
      </div>

      <div class="input-row" fxLayout="row wrap" fxLayoutGap="2.5rem">
        <div fxFlex="50 0 20rem">
          <mat-form-field fxFlex="50 0 20rem">
            <mat-select required name="language" formControlName="doi" [multiple]="true"
                        placeholder="{{'testing-cards-lot.form.placeholder.doi' | translate  }}">
              <mat-option *ngFor="let possibleValue of doiPossibleValue" [value]="possibleValue.id">
                {{ possibleValue.type }} / {{ possibleValue.name }}
              </mat-option>
            </mat-select>

            <mat-error>
              <default-errors [fieldName]="'doi'" [form]="form"></default-errors>
            </mat-error>
          </mat-form-field>
        </div>

        <mat-form-field fxFlex="50 0 20rem">
          <mat-select required name="language" formControlName="language"
                      placeholder="{{'testing-cards-lot.form.placeholder.language' | translate  }}">
            <mat-option *ngFor="let possibleValue of testingCardLanguagePossibleValues" [value]="possibleValue">
              {{"dictionary.testing-card-language." + possibleValue | translate}}
            </mat-option>
          </mat-select>

          <mat-error>
            <default-errors [fieldName]="'language'" [form]="form"></default-errors>
          </mat-error>
        </mat-form-field>
      </div>

    </mat-card-content>

    <mat-card-actions *ngIf="!readOnly">
      <div fxLayout fxLayoutAlign="end">
        <button mat-raised-button
                id="saveButton"
                color="primary"
                type="submit"
                (click)="save()">{{'global.actions.save' | translate | uppercase}}
        </button>
      </div>
    </mat-card-actions>
  </mat-card>
</form>

